Tutorial
========

This tutorial provides instructions (with examples), basic and end-to-end examples to help user to learn optimize models by Intel® Neural Compressor. 

## Instructions with Examples

[Usage Example](/docs/tutorial/usage_example.md)


## Helloworld Examples

1.  Built-in dataloader and metric example: see [tf_example1](/examples/helloworld/tf_example1) for more details.
2.  TensorFlow checkpoint: see [tf_example4](/examples/helloworld/tf_example4) for more details.
3.  Enable benchmark for performance and accuracy measurement: see [tf_example5](/examples/helloworld/tf_example5) for more details.
4.  TensorFlow slim model: see [tf_example3](/examples/helloworld/tf_example3) for more details.

## Tutorial Examples

These examples are **easy** to run without preparing dataset. The script will download public dataset automatically or create fake dataset.

1. Compare existed FP32 & INT8 ResNet50 model directly: [Performance of FP32 Vs. INT8 ResNet50 Model](/docs/tutorial/perf_fp32_int8_tf).
2. An End-To-End pipeline to build up a CNN model by Pytorch to recognize fashion image and speed up AI model by Intel® Neural Compressor: [Intel® Neural Compressor Sample for PyTorch*](/docs/tutorial/pytorch/alexnet_fashion_mnist)
3. An End-To-End pipeline to build up a CNN model by Tensorflow to recognize handwriting number and speed up AI model by Intel® Neural Compressor: [Intel® Neural Compressor Sample for TensorFlow*](/docs/tutorial/tensorflow/alexnet_mnist)


